using System;
using System.Collections.Generic;
using System.Text;

namespace FFDShowAPI
{
    public class FFDShowConstants
    {
        /// <summary>
        /// No instanciation for this class
        /// </summary>
        private FFDShowConstants()
        {
        }
        public const string FFDSHOW_NAME_L = "ffdshow Video Decoder";
        public const string FFDSHOWDXVA_NAME_L = "ffdshow DXVA Video Decoder";
        public const string FFDSHOWRAW_NAME_L = "ffdshow raw video filter";
        public const string FFDSHOWVFW_NAME_L = "ffdshow VFW decoder helper";
        
        /// <summary>
        /// Parameter Id of FFDShow to set/get
        /// </summary>
        public enum FFDShowDataId : int
        {
            IDFF_autoPreset = 1, //automatic preset loading enabled
            IDFF_trayIcon = 3, //is tray icon visible
            IDFF_trayIconExt = 69, //show extended tray icon tip
            //IDFF_trayHwnd=34
            //IDFF_cfgDlgHwnd=4, //handle of configuration dialog
            IDFF_autoPresetFileFirst = 5, //try to load preset from file
            IDFF_autoLoadedFromFile = 6,
            IDFF_filterMode = 7,
            IDFF_FILTERMODE_PLAYER = 1,
            IDFF_FILTERMODE_CONFIG = 2,
            IDFF_FILTERMODE_PROC = 4,
            IDFF_FILTERMODE_VFW = 8,
            IDFF_FILTERMODE_VIDEO = 256,
            IDFF_FILTERMODE_VIDEORAW = 512,
            IDFF_FILTERMODE_AUDIO = 1024,
            IDFF_FILTERMODE_ENC = 2048,
            IDFF_FILTERMODE_AUDIORAW = 4096,
            IDFF_currentFrame = 14,
            IDFF_decodingFps = 15,
            IDFF_buildHistogram = 16,
            //IDFF_AVIfourcc=18,
            //IDFF_AVIaspectX=27,
            //IDFF_AVIaspectY=28,
            IDFF_AVIcolorspace = 96,
            //IDFF_subFlnmChanged=20,
            IDFF_workaroundBugs = 25,
            IDFF_errorConcealment = 70,
            IDFF_errorResilience = 71,
            IDFF_fastMpeg2 = 90,
            IDFF_fastH264 = 91,
            IDFF_libtheoraPostproc = 92,
            //IDFF_subCurrentFlnm=29,
            //IDFF_lastFrameLength=41,
            IDFF_movieDuration = 38,
            IDFF_installPath = 35,
            IDFF_availableCpuFlags = 77, // CPU flags supported by CPU,
            IDFF_allowedCpuFlags = 78, // CPU flags allowed by user,
            IDFF_cpuFlags = 36, // IDFF_availableCpuFlags&IDFF_allowedCpuFlags,
            IDFF_notreg = 47,
            IDFF_multipleInstances = 66, // 0 - allow multiple instances of ffdshow in graph to be connected to each other, 1 - only check previous filter, 2 - check all filters in graph,
            IDFF_isBlacklist = 93,
            IDFF_blacklist = 94,
            //IDFF_xvidInited=68,
            IDFF_defaultMerit = 72,
            IDFF_subCurLang = 73,
            IDFF_addToROT = 74,
            IDFF_streamsOptionsMenu = 75,
            IDFF_dvdproc = 76,
            IDFF_ac3drc = 79,
            IDFF_dtsdrc = 80,
            IDFF_supDVDdec = 81,
            //IDFF_neroavc=82,
            IDFF_unicodeOS = 87,
            IDFF_numLAVCdecThreads = 97,
            IDFF_multiThreadDec = 98,
            IDFF_dontQueueInWMP = 99,
            IDFF_dropOnDelay = 124,
            IDFF_dropOnDelayTime = 125,
            IDFF_h264skipOnDelay = 126,
            IDFF_h264skipOnDelayTime = 127,
            IDFF_useQueueOnlyIn = 128,
            IDFF_useQueueOnlyInList = 129,

            IDFF_outputdebug = 43,
            IDFF_outputdebugfile = 44,
            IDFF_debugfile = 45,
            IDFF_errorbox = 46,

            IDFF_dlgRestorePos = 9,
            IDFF_dlgPosX = 10,
            IDFF_dlgPosY = 11,
            IDFF_lvWidth0 = 12,
            IDFF_showHints = 13,
            IDFF_lastPage = 2, //last active page in configuration dialog,
            IDFF_defaultPreset = 19,
            IDFF_lvKeysWidth0 = 21,
            IDFF_lvKeysWidth1 = 22,
            IDFF_lang = 32,
            IDFF_alwaysOnTop = 67, // was 35 - conflicted with IDFF_installPath,
            IDFF_applying = 37,
            IDFF_lvCodecsWidth0 = 39,
            IDFF_lvCodecsWidth1 = 40,
            IDFF_lvCodecsWidth2 = 48,
            IDFF_lvCodecsSelected = 42,
            IDFF_dlgCustColor0 = 50,
            IDFF_dlgCustColor1 = 51,
            IDFF_dlgCustColor2 = 52,
            IDFF_dlgCustColor3 = 53,
            IDFF_dlgCustColor4 = 54,
            IDFF_dlgCustColor5 = 55,
            IDFF_dlgCustColor6 = 56,
            IDFF_dlgCustColor7 = 57,
            IDFF_dlgCustColor8 = 58,
            IDFF_dlgCustColor9 = 59,
            IDFF_dlgCustColor10 = 60,
            IDFF_dlgCustColor11 = 61,
            IDFF_dlgCustColor12 = 62,
            IDFF_dlgCustColor13 = 63,
            IDFF_dlgCustColor14 = 64,
            IDFF_dlgCustColor15 = 65,
            IDFF_lvConvolverWidth0 = 83,
            IDFF_lvConvolverWidth1 = 84,
            IDFF_lvConvolverWidth2 = 85,
            IDFF_lvConvolverSelected = 86,
            IDFF_dlgDecCurrentPage = 88,
            IDFF_dlgEncCurrentPage = 89,
            IDFF_dlgVolumeDb = 95,

            IDFF_presetAutoloadSize = 1902, //should preset be autoloaded depending on movie dimensions,
            IDFF_presetAutoloadSizeXmin = 1903,
            IDFF_presetAutoloadSizeXmax = 1904,
            IDFF_presetAutoloadSizeCond = 1905, //0 - and, 1 - or,
            IDFF_presetAutoloadSizeYmin = 1906,
            IDFF_presetAutoloadSizeYmax = 1907,
            /*
            IDFF_presetAutoloadFlnm=1901, //should preset be autoloaded depending on filename,
            IDFF_presetAutoloadExt=1908, //should preset be autoloaded depending on file ext,
            IDFF_presetAutoloadExts=1909, //extensions,
            IDFF_presetAutoloadExe=1910,
            IDFF_presetAutoloadExes=1911,
            IDFF_presetAutoloadVolumeName=1912,
            IDFF_presetAutoloadVolumeNames=1913,
            IDFF_presetAutoloadVolumeSerial=1914,
            IDFF_presetAutoloadVolumeSerials=1915,
            */

            IDFF_filterPostproc = 100,
            IDFF_isPostproc = 106,
            IDFF_showPostproc = 120,
            IDFF_orderPostproc = 109,
            IDFF_fullPostproc = 111,
            IDFF_halfPostproc = 121,
            IDFF_postprocMethod = 114, //0 - mplayer, 1 - nic, 2 - mplayer+nic, 3 - none, 4 - spp,
            IDFF_postprocMethodNicFirst = 117,
            IDFF_ppqual = 101, //postprocessing quality set by user (active when not autoq),
            IDFF_autoq = 102, //is automatic postprocessing control enabled?,
            IDFF_ppIsCustom = 103, //custom postprocessing settings are enabled,
            IDFF_ppcustom = 104, //custom postprocessing settings,
            IDFF_currentq = 105,
            IDFF_deblockMplayerAccurate = 123,
            IDFF_deblockStrength = 110,
            IDFF_levelFixLum = 107,
            //IDFF_levelFixChrom=108,
            IDFF_fullYrange = 112,
            IDFF_postprocNicXthresh = 115,
            IDFF_postprocNicYthresh = 116,
            IDFF_postprocSPPmode = 119,
            IDFF_postprocH264mode = 122, //0 - never, 1 - always, 2 - when decoding h.264, 3 - when decoding h.264 and decoder deblocking is off,

            IDFF_filterDeinterlace = 1400,
            IDFF_isDeinterlace = 1401,
            IDFF_showDeinterlace = 1418,
            IDFF_orderDeinterlace = 1424,
            IDFF_fullDeinterlace = 1402,
            IDFF_swapFields = 1409,
            IDFF_deinterlaceMethod = 1403,
            IDFF_tomocompSE = 1407,
            IDFF_tomocompVF = 1414,
            IDFF_dscalerDIflnm = 1412,
            IDFF_dscalerDIcfg = 1413,
            IDFF_frameRateDoublerThreshold = 1416,
            IDFF_frameRateDoublerSE = 1417,
            IDFF_kernelDeintThreshold = 1420,
            IDFF_kernelDeintSharp = 1421,
            IDFF_kernelDeintTwoway = 1422,
            IDFF_kernelDeintMap = 1423,
            IDFF_kernelDeintLinked = 1428,
            IDFF_dgbobMode = 1425,
            IDFF_dgbobThreshold = 1426,
            IDFF_dgbobAP = 1427,

            IDFF_isDecimate = 1410,
            IDFF_decimateRatio = 1411,

            IDFF_filterPictProp = 200,
            IDFF_isPictProp = 205,
            IDFF_showPictProp = 217,
            IDFF_orderPictProp = 207,
            IDFF_fullPictProp = 213,
            IDFF_halfPictProp = 218,
            IDFF_lumGain = 201, //luminance gain,
            IDFF_lumOffset = 202, //luminance offset,
            IDFF_gammaCorrection = 206, //gamma correction (*100),
            IDFF_gammaCorrectionR = 214, //red gamma correction (*100),
            IDFF_gammaCorrectionG = 215, //green gamma correction (*100),
            IDFF_gammaCorrectionB = 216, //blue gamma correction (*100),
            IDFF_hue = 203, //hue,
            IDFF_saturation = 204, //saturation,
            IDFF_colorizeStrength = 219,
            IDFF_colorizeColor = 220,
            IDFF_colorizeChromaonly = 221,
            IDFF_pictPropLevelFix = 222,
            IDFF_pictPropLevelFixFull = 223,
            IDFF_scanlineEffect = 224,

            IDFF_filterLevels = 1600,
            IDFF_isLevels = 1601,
            IDFF_showLevels = 1611,
            IDFF_orderLevels = 1602,
            IDFF_fullLevels = 1603,
            IDFF_halfLevels = 1612,
            IDFF_levelsMode = 1613, // 0 - classic, 1 - Ylevels, 2 - YlevelsG, 3 - YlevelsS, 4 - YlevelsC,
            IDFF_levelsInMin = 1604,
            IDFF_levelsGamma = 1605,
            IDFF_levelsInMax = 1606,
            IDFF_levelsOutMin = 1607,
            IDFF_levelsOutMax = 1608,
            IDFF_levelsOnlyLuma = 1609,
            IDFF_levelsFullY = 1610,
            IDFF_levelsPosterize = 1614,
            IDFF_levelsInAuto = 1615,
            IDFF_levelsNumPoints = 1616,
            IDFF_levelsPoint0x = 1617,
            IDFF_levelsPoint0y = 1618,
            IDFF_levelsPoint1x = 1619,
            IDFF_levelsPoint1y = 1620,
            IDFF_levelsPoint2x = 1621,
            IDFF_levelsPoint2y = 1622,
            IDFF_levelsPoint3x = 1623,
            IDFF_levelsPoint3y = 1624,
            IDFF_levelsPoint4x = 1625,
            IDFF_levelsPoint4y = 1626,
            IDFF_levelsPoint5x = 1627,
            IDFF_levelsPoint5y = 1628,
            IDFF_levelsPoint6x = 1629,
            IDFF_levelsPoint6y = 1630,
            IDFF_levelsPoint7x = 1631,
            IDFF_levelsPoint7y = 1632,
            IDFF_levelsPoint8x = 1633,
            IDFF_levelsPoint8y = 1634,
            IDFF_levelsPoint9x = 1635,
            IDFF_levelsPoint9y = 1636,

            IDFF_flip = 301, //should output video be flipped?,
            IDFF_idct = 601, //IDCT function user (0 - libavcodec simple 16383, 1 - libavcodec normal, 2 - reference, 3 - skal's),
            IDFF_videoDelay = 1801, //video delay in ms,
            IDFF_isVideoDelayEnd = 1802,
            IDFF_videoDelayEnd = 1803,
            IDFF_hwOverlayAspect = 1351, //0 - VIDEOINFOHEADER, 1 - VIDEOINFOHEADER2, 2 - VIDEOINFOHEADER2, then VIDEOINFOHEADER,
            IDFF_grayscale = 602, //only grayscale decoding - faster,

            IDFF_filterSharpen = 400,
            IDFF_isSharpen = 401, //is xshapen filter active?,
            IDFF_showSharpen = 427,
            IDFF_orderSharpen = 407,
            IDFF_fullSharpen = 408,
            IDFF_halfSharpen = 428,
            IDFF_sharpenMethod = 406, //0 - xsharpen, 1 - unsharp, 2 - msharpen, 4 - asharp, 5 - mplayer,
            IDFF_xsharp_strength = 402, //xsharpen filter strength,
            IDFF_xsharp_threshold = 403, //xsharpen filter threshold,
            IDFF_unsharp_strength = 404, //unsharp filter strength,
            IDFF_unsharp_threshold = 405, //unsharp filter threshold,
            IDFF_msharp_strength = 413,
            IDFF_msharp_threshold = 414,
            IDFF_msharpHQ = 415,
            IDFF_msharpMask = 416,
            IDFF_asharpT = 423,
            IDFF_asharpD = 424,
            IDFF_asharpB = 425,
            IDFF_asharpHQBF = 426,
            IDFF_mplayerSharpLuma = 440,
            IDFF_mplayerSharpChroma = 441,

            IDFF_filterWarpsharp = 430,
            IDFF_isWarpsharp = 431,
            IDFF_showWarpsharp = 442,
            IDFF_orderWarpsharp = 432,
            IDFF_fullWarpsharp = 433,
            IDFF_halfWarpsharp = 443,
            IDFF_warpsharpMethod = 434, //0 - warpsharp, 1 - aWarpSharp,
            IDFF_warpsharpDepth = 419,
            IDFF_warpsharpThreshold = 420,
            IDFF_awarpsharpDepth = 435,
            IDFF_awarpsharpThresh = 436,
            IDFF_awarpsharpBlur = 437,
            IDFF_awarpsharpCM = 438, //0 - none, 1 - downsampled, 2 - independant,
            IDFF_awarpsharpBM = 439, //0 - hq 3-pass, 1 - fast 3-pass, 2 - fast 1-pass,

            IDFF_filterDCT = 450,
            IDFF_isDCT = 451,
            IDFF_showDCT = 462,
            IDFF_orderDCT = 452,
            IDFF_fullDCT = 453,
            IDFF_halfDCT = 463,
            IDFF_dctMode = 464,
            IDFF_dct0 = 454,
            IDFF_dct1 = 455,
            IDFF_dct2 = 456,
            IDFF_dct3 = 457,
            IDFF_dct4 = 458,
            IDFF_dct5 = 459,
            IDFF_dct6 = 460,
            IDFF_dct7 = 461,
            IDFF_dctQuant = 465,
            IDFF_dctMatrix0 = 466,
            IDFF_dctMatrix1 = 467,
            IDFF_dctMatrix2 = 468,
            IDFF_dctMatrix3 = 469,
            IDFF_dctMatrix4 = 470,
            IDFF_dctMatrix5 = 471,
            IDFF_dctMatrix6 = 472,
            IDFF_dctMatrix7 = 473,
            IDFF_dctMatrix8 = 474,
            IDFF_dctMatrix9 = 475,
            IDFF_dctMatrix10 = 476,
            IDFF_dctMatrix11 = 477,
            IDFF_dctMatrix12 = 478,
            IDFF_dctMatrix13 = 479,
            IDFF_dctMatrix14 = 480,
            IDFF_dctMatrix15 = 481,

            IDFF_filterNoise = 500,
            IDFF_isNoise = 501, //is noising filter active?,
            IDFF_showNoise = 512,
            IDFF_orderNoise = 506,
            IDFF_fullNoise = 507,
            IDFF_halfNoise = 513,
            IDFF_noiseMethod = 505, //0 - my noise, 1 - avih noise, 2 - mplayer,
            IDFF_uniformNoise = 502, //is uniform noise active (applies only to luma noise now)?,
            IDFF_noisePattern = 510,
            IDFF_noiseAveraged = 511,
            IDFF_noiseStrength = 503, //luma noise strength,
            IDFF_noiseStrengthChroma = 504, //chroma noise strength,
            IDFF_noiseFlickerA = 514,
            IDFF_noiseFlickerF = 515,
            IDFF_noiseShakeA = 516,
            IDFF_noiseShakeF = 517,
            IDFF_noiseLinesA = 518,
            IDFF_noiseLinesF = 519,
            IDFF_noiseLinesC = 524,
            IDFF_noiseLinesTransparency = 520,
            IDFF_noiseScratchesA = 521,
            IDFF_noiseScratchesF = 522,
            IDFF_noiseScratchesC = 525,
            IDFF_noiseScratchesTransparency = 523,

            IDFF_filterResize = 700,
            IDFF_showResize = 751,
            IDFF_isResize = 701, //is resizing active (or will be resizing active),
            IDFF_orderResize = 722,
            IDFF_fullResize = 723,
            IDFF_resizeMode = 728, //0 - exact size, 1 - aspect ratio , 2 - multiply of , 3 - multiply,
            IDFF_resizeDx = 702, //new width,
            IDFF_is_resizeDy_0 = 703, //dummy for backward compatibility,
            IDFF_resizeDy = 705, //new height,
            IDFF_resizeDy_real = 766,
            IDFF_resizeMultOf = 764,
            IDFF_resizeA1 = 729,
            IDFF_resizeA2 = 730,
            IDFF_resizeMult1000 = 753,
            IDFF_resizeIf = 733, //0 - always, 1 - size, 2 - number of pixels,
            IDFF_resizeIfXcond = 734, //-1 - less, 1 - more,
            IDFF_resizeIfXval = 735, //width to be compared to,
            IDFF_resizeIfYcond = 736, //-1 - less, 1 - more,
            IDFF_resizeIfYval = 737, //height to be compared to,
            IDFF_resizeIfXYcond = 738, //0 - and, 1 - or,
            IDFF_resizeIfPixCond = 739, //-1 - less, 1 - more,
            IDFF_resizeIfPixVal = 740,
            IDFF_bordersInside = 755,
            IDFF_bordersUnits = 756, //0 - percent, 1 - pixels,
            IDFF_bordersLocked = 743,
            IDFF_bordersPercentX = 741,
            IDFF_bordersX = IDFF_bordersPercentX,
            IDFF_bordersPercentY = 742,
            IDFF_bordersY = IDFF_bordersPercentY,
            IDFF_bordersPixelsX = 757,
            IDFF_bordersPixelsY = 758,

            IDFF_isAspect = 704, //0 - no aspect ratio correctio, 1 - keep original aspect, 2 - aspect ratio is set in IDFF_aspectRatio,
            IDFF_aspectRatio = 707, //aspect ratio (<<16),

            IDFF_resizeMethodLuma = 706,
            IDFF_resizeMethodChroma = 759,
            IDFF_resizeMethodsLocked = 763,
            IDFF_resizeInterlaced = 748, // 0 - progressive, 1 - interlaced, 2 - use picture type information,
            IDFF_resizeAccurateRounding = 731,
            IDFF_resizeBicubicLumaParam = 724,
            IDFF_resizeBicubicChromaParam = 760,
            IDFF_resizeGaussLumaParam = 726,
            IDFF_resizeGaussChromaParam = 761,
            IDFF_resizeLanczosLumaParam = 727,
            IDFF_resizeLanczosChromaParam = 762,
            IDFF_resizeGblurLum = 708, // *100,
            IDFF_resizeGblurChrom = 709, // *100,
            IDFF_resizeSharpenLum = 710, // *100,
            IDFF_resizeSharpenChrom = 711, // *100,
            IDFF_resizeSimpleWarpXparam = 749, // simple warped resize X param *1000,
            IDFF_resizeSimpleWarpYparam = 750, // simple warped resize Y param *1000,

            IDFF_filterCropNzoom = 747,
            IDFF_isCropNzoom = 712,
            IDFF_showCropNzoom = 752,
            IDFF_orderCropNzoom = 754,
            IDFF_fullCropNzoom = 765,
            IDFF_cropNzoomMode = 713, //0 - zoom, 1 - crop, 2 - pan&scan,
            IDFF_magnificationX = 714,
            IDFF_cropLeft = 715,
            IDFF_cropRight = 716,
            IDFF_cropTop = 717,
            IDFF_cropBottom = 718,
            IDFF_magnificationY = 720,
            IDFF_magnificationLocked = 721,
            IDFF_panscanZoom = 744, //0 - orig size, 100 max zoom,
            IDFF_panscanX = 745, //-100..100 - center x position,
            IDFF_panscanY = 746, //-100..100 - center y position,

            IDFF_filterSubtitles = 800,
            IDFF_isSubtitles = 801,
            IDFF_showSubtitles = 828,
            IDFF_orderSubtitles = 815,
            IDFF_fullSubtitles = 817,
            IDFF_subFilename = 821,
            IDFF_subTempFilename = 3402,
            IDFF_subPosX = 810,
            IDFF_subPosY = 811,
            IDFF_subAlign = 827, //0 - old ffdshow mode, 1 - left, 2 - center, 3 - right,
            IDFF_subExpand = 825, //0 - don't expand, 1 - 4:3, 2 - 16:9, xxxxyyyy - custom,
            IDFF_subIsExpand = 858,
            IDFF_subDelay = 812,
            IDFF_subSpeed = 813,
            IDFF_subSpeed2 = 830,
            IDFF_subAutoFlnm = 814,
            IDFF_subSearchDir = 822,
            IDFF_subSearchHeuristic = 856,
            IDFF_subWatch = 826,
            IDFF_subStereoscopic = 833,
            IDFF_subStereoscopicPar = 834, // stereoscopic paralax <-10%,10%> of picture width,
            IDFF_subDefLang = 836,
            IDFF_subDefLang2 = 852,
            IDFF_subVobsub = 835,
            IDFF_subVobsubAA = 837,
            IDFF_subVobsubAAswgauss = 851,
            IDFF_subVobsubChangePosition = 849,
            IDFF_subVobsubScale = 850,
            IDFF_subLinespacing = 838,
            IDFF_subTimeOverlap = 839,
            IDFF_subIsMinDuration = 840,
            IDFF_subMinDurationType = 841, //0 - subtitle, 1 - line, 2 - character,
            IDFF_subMinDurationSub = 842,
            IDFF_subMinDurationLine = 843,
            IDFF_subMinDurationChar = 844,
            IDFF_subTextpin = 845,
            IDFF_subTextpinSSA = 861,
            IDFF_subShowEmbedded = 857, //id of displayed embedded subtitle, 0 if none,
            //IDFF_subFoundEmbedded=859,
            IDFF_subFix = 846,
            IDFF_subFixLang = 847,
            IDFF_subFixDict = 848,
            IDFF_subOpacity = 853,
            IDFF_subSplitBorder = 855,
            IDFF_subCC = 860,

            IDFF_fontName = 820,
            IDFF_fontCharset = 802,
            IDFF_fontAutosize = 823,
            IDFF_fontAutosizeVideoWindow = 829,
            IDFF_fontSizeP = 803,
            //IDFF_fontSize=803,
            IDFF_fontSizeA = 824,
            IDFF_fontWeight = 804,
            IDFF_fontShadowStrength = 805, //shadow strength (0..100) 100 - subtitles aren't transparent,
            IDFF_fontShadowRadius = 806, //shadow radius,
            IDFF_fontSpacing = 808,
            IDFF_fontColor = 809,
            IDFF_fontSplitting = 831,
            IDFF_fontXscale = 832, // *100, multiplier of character width,
            IDFF_fontYscale = 3411, // *100, multiplier of character width,
            IDFF_fontFast = 854,

            IDFF_filterBlur = 900,
            IDFF_isBlur = 901,
            IDFF_showBlur = 936,
            IDFF_orderBlur = 903,
            IDFF_fullBlur = 905,
            IDFF_halfBlur = 937,
            IDFF_blurIsSoften = 921,
            IDFF_blurStrength = 902,
            IDFF_blurIsTempSmooth = 922,
            IDFF_tempSmooth = 904,
            IDFF_tempSmoothColor = 912,
            IDFF_blurIsSmoothLuma = 923,
            IDFF_smoothStrengthLuma = 908,
            IDFF_blurIsSmoothChroma = 926,
            IDFF_smoothStrengthChroma = 909,
            IDFF_blurIsGradual = 924,
            IDFF_gradualStrength = 913,
            IDFF_blurIsMplayerTNR = 925,
            IDFF_mplayerTNR1 = 915,
            IDFF_mplayerTNR2 = 916,
            IDFF_mplayerTNR3 = 917,
            IDFF_blurIsMplayer = 927,
            IDFF_mplayerBlurRadius = 928,
            IDFF_mplayerBlurLuma = 929,
            IDFF_mplayerBlurChroma = 930,
            IDFF_blurIsDenoise3d = 931,
            IDFF_denoise3Dluma = 932,
            IDFF_denoise3Dchroma = 933,
            IDFF_denoise3Dtime = 934,
            IDFF_denoise3Dhq = 935,

            IDFF_filterOffset = 1100,
            IDFF_isOffset = 1101,
            IDFF_showOffset = 1110,
            IDFF_orderOffset = 1102,
            IDFF_fullOffset = 1109,
            IDFF_halfOffset = 1111,
            IDFF_offsetY_X = 1103,
            IDFF_offsetY_Y = 1104,
            IDFF_offsetU_X = 1105,
            IDFF_offsetU_Y = 1106,
            IDFF_offsetV_X = 1107,
            IDFF_offsetV_Y = 1108,
            IDFF_transfFlip = 1112,
            IDFF_transfMirror = 1113,

            IDFF_filterGradFun = 1150,
            IDFF_isGradFun = 1151,
            IDFF_showGradFun = 1152,
            IDFF_orderGradFun = 1153,
            IDFF_fullGradFun = 1154,
            IDFF_halfGradFun = 1155,
            IDFF_gradFunThreshold = 1156,

            IDFF_filterVis = 1200,
            IDFF_isVis = 1201,
            IDFF_showVis = 1206,
            IDFF_orderVis = 1202,
            IDFF_visMV = 1203,
            IDFF_visQuants = 1204,
            IDFF_visGraph = 1205,

            IDFF_filterAvisynth = 1250,
            IDFF_isAvisynth = 1251,
            IDFF_showAvisynth = 1260,
            IDFF_orderAvisynth = 1252,
            IDFF_fullAvisynth = 1253,
            IDFF_avisynthScript = 1254,
            IDFF_avisynthInYV12 = 1255,
            IDFF_avisynthInYUY2 = 1256,
            IDFF_avisynthInRGB24 = 1257,
            IDFF_avisynthInRGB32 = 1258,
            IDFF_avisynthFfdshowSource = 1259,

            IDFF_isOSD = 1501,
            IDFF_OSDfontName = 1509,
            IDFF_OSDfontCharset = 1502,
            IDFF_OSDfontSize = 1503,
            IDFF_OSDfontWeight = 1504,
            IDFF_OSDfontShadowStrength = 1505,
            IDFF_OSDfontShadowRadius = 1506,
            IDFF_OSDfontSpacing = 1507,
            IDFF_OSDfontColor = 1508,
            IDFF_OSDfontXscale = 1532,
            IDFF_OSDfontFast = 1535,
            IDFF_OSDtype_inputSize = 1520,
            IDFF_OSDtype_inputAspect = 1550,
            IDFF_OSDtype_inputSizeAspect = 1552,
            IDFF_OSDtype_outputSize = 1521,
            IDFF_OSDtype_outputAspect = 1551,
            IDFF_OSDtype_cpuUsage = 1522,
            IDFF_OSDtype_TimeOnffdshow = 1565,
            IDFF_OSDtype_systemTime = 1523,
            IDFF_OSDtype_meanQuant = 1524,
            IDFF_OSDtype_currentFrameTime = 1525,
            IDFF_OSDtype_remainingFrameTime = 1526,
            IDFF_OSDtype_movieTime = 1527,
            IDFF_OSDtype_bps = 1529,
            IDFF_OSDtype_encoderInfo = 1531,
            IDFF_OSDtype_shortMsg = 1528,
            IDFF_OSDtype_shortInfo = 1536,
            IDFF_OSDtype_gmcWarpPoints = 1539,
            IDFF_OSDtype_movieSource = 33,
            IDFF_MOVIE_NONE = 0,
            IDFF_MOVIE_LAVC = 1,
            //IDFF_MOVIE_XVID=2,
            IDFF_MOVIE_THEO = 3,
            IDFF_MOVIE_RAW = 4,
            IDFF_MOVIE_LIBMPEG2 = 5,
            IDFF_MOVIE_MPLAYER = 6,
            IDFF_MOVIE_LIBMAD = 7,
            IDFF_MOVIE_LIBFAAD = 8,
            IDFF_MOVIE_XVID4 = 9,
            IDFF_MOVIE_AVIS = 10,
            IDFF_MOVIE_WMV9 = 12,
            IDFF_MOVIE_SKAL = 13,
            IDFF_MOVIE_LIBA52 = 15,
            IDFF_MOVIE_SPDIF = 16,
            IDFF_MOVIE_LIBDTS = 17,
            IDFF_MOVIE_TREMOR = 18,
            IDFF_MOVIE_REALAAC = 19,
            IDFF_MOVIE_AUDX = 20,
            IDFF_MOVIE_MAX = 20, // max should equal highest value (see rev. 2540),
            IDFF_OSDtype_accurDeblock = 30,
            IDFF_OSDtype_outputFOURCC = 1540,
            IDFF_OSDtype_inputFPS = 1541,
            IDFF_OSDtype_sourceFlnm = 1542,
            IDFF_OSDtype_inputFOURCC = 1543,
            IDFF_OSDtype_inCodecString = 1544,
            IDFF_OSDtype_outCodecString = 1545,
            IDFF_OSDtype_outSpeakersConfig = 1549,
            IDFF_frameType = 31,
            IDFF_frameSize = 41,
            IDFF_OSDtype_frameMD5 = 1548,
            IDFF_OSDtype_frameTimestamps = 1553,
            IDFF_OSDtype_frameDuration = 1554,
            IDFF_OSDtype_exeflnm = 1556,
            IDFF_OSDtype_sourceFlnmWOpath = 1557,
            IDFF_OSDtype_sampleFrequency = 1558,
            IDFF_OSDtype_nchannels = 1559,
            IDFF_OSDtype_audioSampleFormat = 1560,
            IDFF_OSDtype_audioJitter = 1561,
            IDFF_OSDtype_timetable = 1562,
            IDFF_OSDtype_QueueCount = 1563,
            IDFF_OSDtype_Late = 1564,
            IDFF_OSDuser = 1511, //don't use these, use drawOSD() instead,
            IDFF_OSDuserPx = 1512,
            IDFF_OSDuserPy = 1513,
            IDFF_OSDcurPreset = 1530,
            IDFF_OSDposX = 1533,
            IDFF_OSDposY = 1534,
            IDFF_OSDstartPreset = 1537,
            IDFF_OSDstartDuration = 1538, //in frames,
            IDFF_OSDisSave = 1546,
            IDFF_OSDsaveFlnm = 1547,
            IDFF_OSDsaveOnly = 1555,

            IDFF_filterGrab = 2000,
            IDFF_isGrab = 2001,
            IDFF_showGrab = 2013,
            IDFF_orderGrab = 2002,
            IDFF_fullGrab = 2003,
            IDFF_grabPath = 2004,
            IDFF_grabPrefix = 2005,
            IDFF_grabDigits = 2006,
            IDFF_grabFormat = 2007, //0 - jpeg, 1 - bmp, 2 - png,
            IDFF_grabMode = 2008, //0 - all frames, 1 - one frame (grabFrameNum), 2 - range (grabFrameNum1-grabFrameNum2),
            IDFF_grabFrameNum = 2009,
            IDFF_grabFrameNum1 = 2010,
            IDFF_grabFrameNum2 = 2011,
            IDFF_grabQual = 2012, //0..100,
            IDFF_grabStep = 2014,
            //IDFF_grabNow=2015,

            IDFF_filterLogoaway = 1450,
            IDFF_isLogoaway = 1451,
            IDFF_showLogoaway = 1452,
            IDFF_orderLogoaway = 1453,
            IDFF_fullLogoaway = 1454,
            IDFF_logoawayX = 1455,
            IDFF_logoawayY = 1456,
            IDFF_logoawayDx = 1457,
            IDFF_logoawayDy = 1458,
            IDFF_logoawayMode = 1459,
            IDFF_logoawayBlur = 1460,
            IDFF_logoawayPointnw = 1461,
            IDFF_logoawayPointne = 1462,
            IDFF_logoawayPointsw = 1463,
            IDFF_logoawayPointse = 1464,
            IDFF_logoawayBordn_mode = 1465,
            IDFF_logoawayBorde_mode = 1466,
            IDFF_logoawayBords_mode = 1467,
            IDFF_logoawayBordw_mode = 1468,
            IDFF_logoawayVhweight = 1469,
            IDFF_logoawaySolidcolor = 1470,
            IDFF_logoawayLumaOnly = 1471,
            IDFF_logoawayParamBitmapFlnm = 1473,

            IDFF_filterBitmap = 1650,
            IDFF_isBitmap = 1651,
            IDFF_showBitmap = 1652,
            IDFF_orderBitmap = 1653,
            IDFF_fullBitmap = 1654,
            IDFF_bitmapFlnm = 1655,
            IDFF_bitmapPosx = 1656,
            IDFF_bitmapPosy = 1657,
            IDFF_bitmapPosmode = 1658,
            IDFF_bitmapAlign = 1659,
            IDFF_bitmapMode = 1660,
            IDFF_bitmapStrength = 1661,

            IDFF_overlayControl = 2100,
            IDFF_isOverlayControl = 2101,
            IDFF_overlayOrder = 2109, // read-only,
            IDFF_overlayBrightness = 2102,
            IDFF_overlayContrast = 2103,
            IDFF_overlayHue = 2104,
            IDFF_overlaySaturation = 2105,
            IDFF_overlaySharpness = 2106,
            IDFF_overlayGamma = 2107,
            IDFF_overlayColorEnable = 2108,

            IDFF_isKeys = 1701,
            IDFF_keysAlways = 1702,
            IDFF_keysShortOsd = 1707,
            IDFF_keysSeek1 = 1708,
            IDFF_keysSeek2 = 1709,

            IDFF_isRemote = 1750,
            IDFF_remoteMessageMode = 1751, // 0 - use RegisterWindowMessage, 1 - let user specify message number (default WM_APP+18),
            IDFF_remoteMessageUser = 1752,
            IDFF_remoteAcceptKeys = 1753, // remote API window accepts keyboard messages,

            IDFF_isMouse = 1770,
            IDFF_mouseAlways = 1771,

            IDFF_xvid = 1001, //are AVIs with this FOURCC played by ffdshow?,
            IDFF_div3 = 1002,
            IDFF_divx = 1003,
            IDFF_dx50 = 1004,
            IDFF_fvfw = 1022,
            IDFF_mp43 = 1005,
            IDFF_mp42 = 1006,
            IDFF_mp41 = 1007,
            IDFF_h263 = 1008,
            IDFF_h264 = 1047,
            IDFF_h261 = 1065,
            IDFF_wmv1 = 1011,
            IDFF_wmv2 = 1017,
            IDFF_wmv3 = 1042,
            IDFF_vc1 = 1090,
            IDFF_cavs = 1091,
            IDFF_vmnc = 1092,
            IDFF_vp5 = 1093,
            IDFF_vp6 = 1094,
            IDFF_vp6f = 1095,
            IDFF_rt21 = 1096,
            IDFF_vixl = 1097,
            IDFF_aasc = 1098,
            IDFF_qtrpza = 1099,
            IDFF_mjpg = 1014,
            IDFF_dvsd = 1015,
            IDFF_hfyu = 1016,
            IDFF_cyuv = 1019,
            IDFF_mpg1 = 1012,
            IDFF_mpg2 = 1013,
            IDFF_mpegAVI = 1021,
            IDFF_asv1 = 1020,
            IDFF_vcr1 = 1040,
            IDFF_rle = 1041,
            IDFF_theo = 1023,
            IDFF_rv10 = 1037,
            IDFF_ffv1 = 1038,
            IDFF_vp3 = 1039,
            IDFF_tscc = 1060,
            IDFF_rawv = 1009, // 0 - unsupported, 1 - all, 2 - all YUV, 3 - all RGB, else FOURCC of accepted colorspace,
            IDFF_isDyInterlaced = 1330, // enable height dependant interlaced colorspace conversions,
            IDFF_dyInterlaced = 1331,
            IDFF_3ivx = 1024,
            IDFF_svq1 = 1025,
            IDFF_svq3 = 1026,
            IDFF_cram = 1027,
            IDFF_iv32 = 1034,
            IDFF_cvid = 1035,
            IDFF_mszh = 1044,
            IDFF_zlib = 1045,
            IDFF_flv1 = 1049,
            IDFF_8bps = 1050,
            IDFF_png1 = 1051,
            IDFF_qtrle = 1052,
            IDFF_duck = 1053,
            IDFF_qpeg = 1064,
            IDFF_loco = 1066,
            IDFF_wnv1 = 1067,
            IDFF_cscd = 1072,
            IDFF_zmbv = 1073,
            IDFF_ulti = 1074,
            IDFF_wma7 = 1028,
            IDFF_wma8 = 1029,
            IDFF_mp2 = 1030,
            IDFF_mp3 = 1031,
            IDFF_ac3 = 1032,
            IDFF_dts = 1057,
            IDFF_dtsinwav = 1059,
            IDFF_aac = 1033,
            IDFF_amr = 1046,
            IDFF_iadpcm = 1054,
            IDFF_msadpcm = 1061,
            IDFF_otherAdpcm = 1069,
            IDFF_law = 1062,
            IDFF_gsm = 1063,
            IDFF_flac = 1055,
            IDFF_tta = 1068,
            IDFF_qdm2 = 1070,
            IDFF_mace = 1075,
            IDFF_truespeech = 1071,
            IDFF_vorbis = 1058,
            IDFF_lpcm = 1056,
            IDFF_wavpack = 1076,
            IDFF_fps1 = 1077,
            IDFF_snow = 1078,
            IDFF_ra = 1079,
            IDFF_imc = 1080,
            IDFF_rawa = 1036,
            IDFF_avisV = 1043,
            IDFF_avisA = 1048,

            IDFF_filterOutputVideo = 1357,
            IDFF_hwOverlay = 1350, // 0 - VIDEOINFOHEADER, 1 - VIDEOINFOHEADER2, 2 - first try VIDEOINFOHEADER2, then VIDEOINFOHEADER,
            IDFF_outI420 = 1309,
            IDFF_outYV12 = 1301,
            IDFF_outYUY2 = 1302,
            IDFF_outYVYU = 1303,
            IDFF_outUYVY = 1304,
            IDFF_outNV12 = 1360,
            IDFF_outRGB32 = 1305,
            IDFF_outRGB24 = 1306,
            IDFF_outRGB555 = 1307,
            IDFF_outRGB565 = 1308,
            IDFF_outClosest = 1356,
            IDFF_outDV = 1358,
            IDFF_outDVnorm = 1359,
            IDFF_allowOutChange = 1352,
            IDFF_outChangeCompatOnly = 1354,
            IDFF_hwDeinterlace = 1353,
            IDFF_hwDeintMethod = 1361,
            IDFF_avisynthYV12_RGB = 1355,

            IDFF_filterOutputAudio = 1314,
            IDFF_outsfs = 1310,
            IDFF_outAC3bitrate = 1313,

            IDFF_aoutConnectTo = 1315,
            IDFF_aoutConnectToOnlySpdif = 1316,

            IDFF_dithering = 1311,
            IDFF_noiseShaping = 1312,

            IDFF_filterDScaler = 2200,
            IDFF_isDScaler = 2201,
            IDFF_showDScaler = 2206,
            IDFF_orderDScaler = 2202,
            IDFF_fullDScaler = 2203,
            IDFF_halfDScaler = 2207,
            IDFF_dscalerFltflnm = 2204,
            IDFF_dscalerCfg = 2205,
            IDFF_dscalerPath = 2208,

            IDFF_filterPerspective = 2300,
            IDFF_isPerspective = 2301,
            IDFF_showPerspective = 2314,
            IDFF_orderPerspective = 2302,
            IDFF_fullPerspective = 2303,
            IDFF_halfPerspective = 2315,
            IDFF_perspectiveIsSrc = 2313,
            IDFF_perspectiveX1 = 2304,
            IDFF_perspectiveY1 = 2305,
            IDFF_perspectiveX2 = 2306,
            IDFF_perspectiveY2 = 2307,
            IDFF_perspectiveX3 = 2308,
            IDFF_perspectiveY3 = 2309,
            IDFF_perspectiveX4 = 2310,
            IDFF_perspectiveY4 = 2311,
            IDFF_perspectiveInterpolation = 2312,

            //----------------------- audio decoding -------------------------,
            IDFF_preferredsfs = 2399,
            IDFF_alwaysextensible = 2398,
            IDFF_allowOutStream = 2397,
            IDFF_vorbisgain = 2396,

            IDFF_filterVolume = 2400,
            IDFF_isVolume = 2401,
            IDFF_showVolume = 2405,
            IDFF_orderVolume = 2402,
            IDFF_volume = 2403,
            IDFF_volumeL = 2408,
            IDFF_volumeC = 2409,
            IDFF_volumeR = 2410,
            IDFF_volumeSL = 2411,
            IDFF_volumeSR = 2412,
            IDFF_volumeLFE = 2413,
            IDFF_volumeLmute = 2415, //1 - mute, 2 - solo,
            IDFF_volumeCmute = 2416,
            IDFF_volumeRmute = 2417,
            IDFF_volumeSLmute = 2418,
            IDFF_volumeSRmute = 2419,
            IDFF_volumeLFEmute = 2420,
            IDFF_volumeNormalize = 2404,
            IDFF_maxNormalization = 2406, //*100,
            IDFF_volumeNormalizeBufferLength = 3368,
            IDFF_volumeNormalizeResetOnSeek = 3369,
            //IDFF_currentNormalization=2407, //*100,
            IDFF_showCurrentVolume = 2414,

            IDFF_filterEQ = 2430,
            IDFF_isEQ = 2431,
            IDFF_showEQ = 2446,
            IDFF_orderEQ = 2432,
            IDFF_eq0 = 2433,
            IDFF_eq1 = 2434,
            IDFF_eq2 = 2435,
            IDFF_eq3 = 2436,
            IDFF_eq4 = 2437,
            IDFF_eq5 = 2438,
            IDFF_eq6 = 2440,
            IDFF_eq7 = 2441,
            IDFF_eq8 = 2442,
            IDFF_eq9 = 2443,
            IDFF_eqLowdb = 2444,
            IDFF_eqHighdb = 2445,
            IDFF_eq0freq = 2447,
            IDFF_eq1freq = 2448,
            IDFF_eq2freq = 2449,
            IDFF_eq3freq = 2450,
            IDFF_eq4freq = 2451,
            IDFF_eq5freq = 2452,
            IDFF_eq6freq = 2453,
            IDFF_eq7freq = 2454,
            IDFF_eq8freq = 2455,
            IDFF_eq9freq = 2456,
            IDFF_eqSuper = 2457,

            IDFF_filterWinamp2 = 2460,
            IDFF_isWinamp2 = 2461,
            IDFF_showWinamp2 = 2466,
            IDFF_orderWinamp2 = 2462,
            IDFF_winamp2flnm = 2463,
            IDFF_winamp2filtername = 2464,
            IDFF_winamp2dir = 2465,

            IDFF_filterFreeverb = 2500,
            IDFF_isFreeverb = 2501,
            IDFF_showFreeverb = 2502,
            IDFF_orderFreeverb = 2503,
            IDFF_freeverbRoomsize = 2504,
            IDFF_freeverbDamp = 2505,
            IDFF_freeverbWet = 2506,
            IDFF_freeverbDry = 2507,
            IDFF_freeverbWidth = 2508,
            IDFF_freeverbMode = 2509,

            IDFF_filterResample = 2530,
            IDFF_isResample = 2531,
            IDFF_showResample = 2532,
            IDFF_orderResample = 2533,
            IDFF_resampleFreq = 2534,
            IDFF_resampleMode = 2535,
            IDFF_resampleIf = 2536, // 0 - always, 1 - conditional,
            IDFF_resampleIfCond = 2537, // -1 - less, 1 - more,
            IDFF_resampleIfFreq = 2538,

            IDFF_filterMixer = 2480,
            IDFF_isMixer = 2481,
            IDFF_showMixer = 2483,
            IDFF_orderMixer = 2484,
            IDFF_mixerOut = 2482,
            IDFF_normalizeMatrix = 2485,
            IDFF_mixerMatrix00 = 2486, // *100000,
            IDFF_mixerMatrix01 = 2487,
            IDFF_mixerMatrix02 = 2488,
            IDFF_mixerMatrix03 = 2489,
            IDFF_mixerMatrix04 = 2490,
            IDFF_mixerMatrix05 = 2491,
            IDFF_mixerMatrix10 = 2492,
            IDFF_mixerMatrix11 = 2493,
            IDFF_mixerMatrix12 = 2494,
            IDFF_mixerMatrix13 = 2495,
            IDFF_mixerMatrix14 = 2496,
            IDFF_mixerMatrix15 = 2497,
            IDFF_mixerMatrix20 = 2498,
            IDFF_mixerMatrix21 = 2499,
            IDFF_mixerMatrix22 = 2600,
            IDFF_mixerMatrix23 = 2601,
            IDFF_mixerMatrix24 = 2602,
            IDFF_mixerMatrix25 = 2603,
            IDFF_mixerMatrix30 = 2604,
            IDFF_mixerMatrix31 = 2605,
            IDFF_mixerMatrix32 = 2606,
            IDFF_mixerMatrix33 = 2607,
            IDFF_mixerMatrix34 = 2608,
            IDFF_mixerMatrix35 = 2609,
            IDFF_mixerMatrix40 = 2610,
            IDFF_mixerMatrix41 = 2611,
            IDFF_mixerMatrix42 = 2612,
            IDFF_mixerMatrix43 = 2613,
            IDFF_mixerMatrix44 = 2614,
            IDFF_mixerMatrix45 = 2615,
            IDFF_mixerMatrix50 = 2616,
            IDFF_mixerMatrix51 = 2617,
            IDFF_mixerMatrix52 = 2618,
            IDFF_mixerMatrix53 = 2619,
            IDFF_mixerMatrix54 = 2620,
            IDFF_mixerMatrix55 = 2621,
            IDFF_customMatrix = 2622,
            IDFF_mixerExpandStereo = 2623,
            IDFF_mixerVoiceControl = 2624,
            IDFF_mixerClev = 2626,
            IDFF_mixerSlev = 2627,
            IDFF_mixerLFElev = 2628,
            IDFF_headphone_dim = 2625,

            IDFF_filterDolbyDecoder = 2650,
            IDFF_isDolbyDecoder = 2651,
            IDFF_showDolbyDecoder = 2652,
            IDFF_orderDolbyDecoder = 2653,
            IDFF_dolbyDecoderDelay = 2654,

            IDFF_filterDelay = 2670,
            IDFF_isDelay = 2671,
            IDFF_showDelay = 2672,
            IDFF_orderDelay = 2673,
            IDFF_delayL = 2674,
            IDFF_delayC = 2675,
            IDFF_delayR = 2676,
            IDFF_delaySL = 2677,
            IDFF_delaySR = 2678,
            IDFF_delayLFE = 2679,

            IDFF_filterFir = 2700,
            IDFF_isFir = 2701,
            IDFF_showFir = 2702,
            IDFF_orderFir = 2703,
            IDFF_firTaps = 2704,
            IDFF_firType = 2705, // 0 - lowpass, 1 - highpass, 2 - band pass, 3 - band stop,
            IDFF_firFreq = 2706,
            IDFF_firWidth = 2707, // for bandpass and bandstop,
            IDFF_firWindow = 2708, // 0 - box, 1 - triangle, 2 - hamming, 3 - hanning, 4 - blackman, 5 - flattop, 6 - kaiser,
            IDFF_firKaiserBeta = 2709, // *1000,
            IDFF_showCurrentFFT = 2710,
            IDFF_firIsUserDisplayMaxFreq = 2711,
            IDFF_firUserDisplayMaxFreq = 2712,
            //IDFF_firCurrentFreq=2713,

            IDFF_filterAudioDenoise = 2550,
            IDFF_isAudioDenoise = 2551,
            IDFF_showAudioDenoise = 2552,
            IDFF_orderAudioDenoise = 2553,
            IDFF_audioDenoiseThreshold = 2554,

            IDFF_isAudioSwitcher = 2570,

            IDFF_filterCrystality = 2750,
            IDFF_isCrystality = 2751,
            IDFF_showCrystality = 2752,
            IDFF_orderCrystality = 2753,
            IDFF_crystality_bext_level = 2754,
            IDFF_crystality_echo_level = 2755,
            IDFF_crystality_stereo_level = 2756,
            IDFF_crystality_filter_level = 2757,
            IDFF_crystality_feedback_level = 2758,
            IDFF_crystality_harmonics_level = 2759,

            IDFF_filterLFEcrossover = 2770,
            IDFF_isLFEcrossover = 2771,
            IDFF_showLFEcrossover = 2772,
            IDFF_orderLFEcrossover = 2773,
            IDFF_LFEcrossoverFreq = 2774,
            IDFF_LFEcrossoverGain = 2775,
            IDFF_LFEcutLR = 2776,

            IDFF_filterChannelSwap = 2800,
            IDFF_isChannelSwap = 2801,
            IDFF_showChannelSwap = 2802,
            IDFF_orderChannelSwap = 2803,
            IDFF_channelSwapL = 2804,
            IDFF_channelSwapR = 2805,
            IDFF_channelSwapC = 2806,
            IDFF_channelSwapSL = 2807,
            IDFF_channelSwapREAR = 2808,
            IDFF_channelSwapSR = 2809,
            IDFF_channelSwapLFE = 2810,

            IDFF_filterConvolver = 2850,
            IDFF_isConvolver = 2851,
            IDFF_showConvolver = 2852,
            IDFF_orderConvolver = 2853,
            IDFF_convolverMappingMode = 2858,
            IDFF_convolverFile = 2854,
            IDFF_convolverFileL = 2859,
            IDFF_convolverFileR = 2860,
            IDFF_convolverFileC = 2861,
            IDFF_convolverFileSL = 2862,
            IDFF_convolverFileSR = 2863,
            IDFF_convolverFileLFE = 2864,
            IDFF_convolverMixingStrength = 2855,
            IDFF_convolverLevelAdjustDB = 2856, // *10,
            IDFF_convolverLevelAdjustAuto = 2857,

            //----------------------- encoding -------------------------,
            IDFF_numthreads = 3322,
            IDFF_enc_mode = 3000,
            IDFF_enc_bitrate1000 = 3001,
            IDFF_enc_desiredSize = 3002,
            IDFF_enc_quant = 3003,
            IDFF_enc_qual = 3004,

            IDFF_enc_codecId = 3005,
            IDFF_enc_fourcc = 3006,

            IDFF_enc_max_key_interval = 3007,
            IDFF_enc_min_key_interval = 3008,
            IDFF_enc_keySceneChange = 3332,
            IDFF_enc_globalHeader = 3009,
            IDFF_enc_part = 3010,
            IDFF_enc_interlacing = 3011,
            IDFF_enc_interlacing_tff = 3358,
            IDFF_enc_gray = 3012,
            IDFF_enc_isBframes = 3013,
            IDFF_enc_max_b_frames = 3014,
            IDFF_enc_b_dynamic = 3015,
            IDFF_enc_b_refine = 3364,
            IDFF_enc_packedBitstream = 3016,
            IDFF_enc_dx50bvop = 3017,
            IDFF_enc_aspectMode = 3018,
            IDFF_enc_sarX1000 = 3019,
            IDFF_enc_sarY1000 = 3020,
            IDFF_enc_darX1000 = 3327,
            IDFF_enc_darY1000 = 3328,
            IDFF_enc_H263Pflags = 3311,

            IDFF_enc_huffyuv_csp = 3021,
            IDFF_enc_huffyuv_pred = 3022,
            IDFF_enc_huffyuv_ctx = 3336,

            IDFF_enc_ljpeg_csp = 3305,

            IDFF_enc_ffv1_coder = 3023,
            IDFF_enc_ffv1_context = 3024,
            IDFF_enc_ffv1_csp = 3025,

            IDFF_enc_wmv9_kfsecs = 3026,
            IDFF_enc_wmv9_ivtc = 3027,
            IDFF_enc_wmv9_deint = 3028,
            IDFF_enc_wmv9_cplx = 3029,
            IDFF_enc_wmv9_crisp = 3030,
            IDFF_enc_wmv9_aviout = 3031,

            IDFF_enc_forceIncsp = 3032,
            IDFF_enc_incsp = 3033,
            IDFF_enc_isProc = 3034,
            IDFF_enc_flip = 3035,
            IDFF_enc_dropFrames = 3331,

            IDFF_enc_storeAVI = 3036,
            IDFF_enc_storeExt = 3037,
            IDFF_enc_storeExtFlnm = 3038,
            IDFF_enc_ownStoreExt = 3216,
            IDFF_enc_muxer = 3039,
            IDFF_enc_ff1_stats_mode = 3040,
            IDFF_enc_ff1_stats_flnm = 3041,
            IDFF_enc_isFPSoverride = 3042,
            IDFF_enc_fpsOverrideNum = 3043,
            IDFF_enc_fpsOverrideDen = 3044,

            IDFF_enc_me_hq = 3045,
            IDFF_enc_me_4mv = 3046,
            IDFF_enc_me_qpel = 3047,
            IDFF_enc_me_gmc = 3048,
            IDFF_enc_me_mv0 = 3217,
            IDFF_enc_me_cbp_rd = 3218,
            IDFF_enc_me_cmp = 3049,
            IDFF_enc_me_cmp_chroma = 3050,
            IDFF_enc_me_subcmp = 3051,
            IDFF_enc_me_subcmp_chroma = 3052,
            IDFF_enc_mb_cmp = 3053,
            IDFF_enc_mb_cmp_chroma = 3054,
            IDFF_enc_dia_size = 3055,
            IDFF_enc_me_last_predictor_count = 3056,
            IDFF_enc_me_prepass = 3057,
            IDFF_enc_me_precmp = 3058,
            IDFF_enc_me_precmp_chroma = 3059,
            IDFF_enc_dia_size_pre = 3060,
            IDFF_enc_me_subq = 3061,
            IDFF_enc_me_nsse_weight = 3321,
            IDFF_enc_me_iterative = 3366,

            IDFF_enc_xvid_motion_search = 3062,
            IDFF_enc_is_xvid_me_custom = 3063,
            IDFF_enc_xvid_me_custom = 3064,
            IDFF_enc_xvid_me_inter4v = 3065,
            IDFF_enc_xvid_vhq = 3066,
            IDFF_enc_xvid_vhq_modedecisionbits = 3067,
            IDFF_enc_is_xvid_vhq_custom = 3068,
            IDFF_enc_xvid_vhq_custom = 3069,

            IDFF_enc_skalSearchMetric = 3310,

            IDFF_enc_quant_type = 3070,
            IDFF_enc_qmatrix_intra_custom0 = 3272,
            IDFF_enc_qmatrix_intra_custom1 = 3273,
            IDFF_enc_qmatrix_intra_custom2 = 3274,
            IDFF_enc_qmatrix_intra_custom3 = 3275,
            IDFF_enc_qmatrix_intra_custom4 = 3276,
            IDFF_enc_qmatrix_intra_custom5 = 3277,
            IDFF_enc_qmatrix_intra_custom6 = 3278,
            IDFF_enc_qmatrix_intra_custom7 = 3279,
            IDFF_enc_qmatrix_intra_custom8 = 3280,
            IDFF_enc_qmatrix_intra_custom9 = 3281,
            IDFF_enc_qmatrix_intra_custom10 = 3282,
            IDFF_enc_qmatrix_intra_custom11 = 3283,
            IDFF_enc_qmatrix_intra_custom12 = 3284,
            IDFF_enc_qmatrix_intra_custom13 = 3285,
            IDFF_enc_qmatrix_intra_custom14 = 3286,
            IDFF_enc_qmatrix_intra_custom15 = 3287,
            IDFF_enc_qmatrix_inter_custom0 = 3288,
            IDFF_enc_qmatrix_inter_custom1 = 3289,
            IDFF_enc_qmatrix_inter_custom2 = 3290,
            IDFF_enc_qmatrix_inter_custom3 = 3291,
            IDFF_enc_qmatrix_inter_custom4 = 3292,
            IDFF_enc_qmatrix_inter_custom5 = 3293,
            IDFF_enc_qmatrix_inter_custom6 = 3294,
            IDFF_enc_qmatrix_inter_custom7 = 3295,
            IDFF_enc_qmatrix_inter_custom8 = 3296,
            IDFF_enc_qmatrix_inter_custom9 = 3297,
            IDFF_enc_qmatrix_inter_custom10 = 3298,
            IDFF_enc_qmatrix_inter_custom11 = 3299,
            IDFF_enc_qmatrix_inter_custom12 = 3300,
            IDFF_enc_qmatrix_inter_custom13 = 3301,
            IDFF_enc_qmatrix_inter_custom14 = 3302,
            IDFF_enc_qmatrix_inter_custom15 = 3303,
            IDFF_enc_qmatrix_intra4x4Y_custom0 = 3342,
            IDFF_enc_qmatrix_intra4x4Y_custom1 = 3343,
            IDFF_enc_qmatrix_intra4x4Y_custom2 = 3344,
            IDFF_enc_qmatrix_intra4x4Y_custom3 = 3345,
            IDFF_enc_qmatrix_inter4x4Y_custom0 = 3346,
            IDFF_enc_qmatrix_inter4x4Y_custom1 = 3347,
            IDFF_enc_qmatrix_inter4x4Y_custom2 = 3348,
            IDFF_enc_qmatrix_inter4x4Y_custom3 = 3349,
            IDFF_enc_qmatrix_intra4x4C_custom0 = 3350,
            IDFF_enc_qmatrix_intra4x4C_custom1 = 3351,
            IDFF_enc_qmatrix_intra4x4C_custom2 = 3352,
            IDFF_enc_qmatrix_intra4x4C_custom3 = 3353,
            IDFF_enc_qmatrix_inter4x4C_custom0 = 3354,
            IDFF_enc_qmatrix_inter4x4C_custom1 = 3355,
            IDFF_enc_qmatrix_inter4x4C_custom2 = 3356,
            IDFF_enc_qmatrix_inter4x4C_custom3 = 3357,
            IDFF_enc_q_i_min = 3104,
            IDFF_enc_q_i_max = 3105,
            IDFF_enc_i_quant_factor = 3106,
            IDFF_enc_i_quant_offset = 3107,
            IDFF_enc_q_p_min = 3108,
            IDFF_enc_q_p_max = 3109,
            IDFF_enc_q_b_min = 3110,
            IDFF_enc_q_b_max = 3111,
            IDFF_enc_q_mb_min = 3112,
            IDFF_enc_q_mb_max = 3113,
            IDFF_enc_trellisquant = 3114,
            IDFF_enc_qns = 3304,
            IDFF_enc_b_quant_factor = 3115,
            IDFF_enc_b_quant_offset = 3116,
            IDFF_enc_isInterQuantBias = 3117,
            IDFF_enc_interQuantBias = 3118,
            IDFF_enc_isIntraQuantBias = 3119,
            IDFF_enc_intraQuantBias = 3120,
            IDFF_enc_dct_algo = 3121,
            IDFF_enc_mpeg2_dc_prec = 3193,

            IDFF_enc_ff1_vratetol = 3122,
            IDFF_enc_ff1_vqcomp = 3123,
            IDFF_enc_ff1_vqblur1 = 3124,
            IDFF_enc_ff1_vqblur2 = 3125,
            IDFF_enc_ff1_vqdiff = 3126,
            IDFF_enc_ff1_rc_squish = 3127,
            IDFF_enc_ff1_rc_max_rate1000 = 3312,
            IDFF_enc_ff1_rc_min_rate1000 = 3313,
            IDFF_enc_ff1_rc_buffer_size = 3314,

            IDFF_enc_dv_profile = 3367,

            IDFF_enc_svcd_scan_offset = 3315,

            IDFF_enc_xvid_rc_reaction_delay_factor = 3128,
            IDFF_enc_xvid_rc_averaging_period = 3129,
            IDFF_enc_xvid_rc_buffer = 3130,

            IDFF_enc_isCreditsStart = 3131,
            IDFF_enc_isCreditsEnd = 3132,
            IDFF_enc_creditsStartBegin = 3133,
            IDFF_enc_creditsStartEnd = 3134,
            IDFF_enc_creditsEndBegin = 3135,
            IDFF_enc_creditsEndEnd = 3136,
            IDFF_enc_credits_mode = 3137,
            IDFF_enc_credits_percent = 3138,
            IDFF_enc_credits_quant_i = 3139,
            IDFF_enc_credits_quant_p = 3140,
            IDFF_enc_credits_size_start = 3141,
            IDFF_enc_credits_size_end = 3142,
            IDFF_enc_graycredits = 3143,

            IDFF_enc_stats1flnm = 3144,
            IDFF_enc_stats2flnm = 3145,
            IDFF_enc_xvid2pass_use_write = 3146,
            IDFF_enc_twopass_max_bitrate = 3147,
            IDFF_enc_twopass_max_overflow_improvement = 3148,
            IDFF_enc_twopass_max_overflow_degradation = 3149,
            IDFF_enc_keyframe_boost = 3150,
            IDFF_enc_kftreshold = 3151,
            IDFF_enc_kfreduction = 3152,
            IDFF_enc_curve_compression_high = 3153,
            IDFF_enc_curve_compression_low = 3154,
            IDFF_enc_bitrate_payback_delay = 3155,
            IDFF_enc_bitrate_payback_method = 3156,
            IDFF_enc_use_alt_curve = 3157,
            IDFF_enc_alt_curve_type = 3158,
            IDFF_enc_alt_curve_high_dist = 3159,
            IDFF_enc_alt_curve_low_dist = 3160,
            IDFF_enc_alt_curve_use_auto = 3161,
            IDFF_enc_alt_curve_auto_str = 3162,
            IDFF_enc_alt_curve_min_rel_qual = 3163,
            IDFF_enc_alt_curve_use_auto_bonus_bias = 3164,
            IDFF_enc_alt_curve_bonus_bias = 3165,

            IDFF_enc_xvid_lum_masking = 3166,
            IDFF_enc_xvid_chromaopt = 3167,
            IDFF_enc_isElimLum = 3168,
            IDFF_enc_elimLumThres = 3169,
            IDFF_enc_isElimChrom = 3170,
            IDFF_enc_elimChromThres = 3171,
            IDFF_enc_is_lavc_nr = 3221,
            IDFF_enc_lavc_nr = 3222,
            IDFF_enc_is_ff_lumi_masking = 3172,
            IDFF_enc_ff_lumi_masking1000 = 3173,
            IDFF_enc_is_ff_temporal_cplx_masking = 3174,
            IDFF_enc_ff_temporal_cplx_masking1000 = 3175,
            IDFF_enc_is_ff_spatial_cplx_masking = 3176,
            IDFF_enc_ff_spatial_cplx_masking1000 = 3177,
            IDFF_enc_is_ff_p_masking = 3178,
            IDFF_enc_ff_p_masking1000 = 3179,
            IDFF_enc_is_ff_dark_masking = 3180,
            IDFF_enc_ff_dark_masking1000 = 3181,
            IDFF_enc_is_ff_border_masking = 3334,
            IDFF_enc_ff_border_masking1000 = 3335,
            IDFF_enc_ff_naq = 3182,
            IDFF_enc_isSkalMasking = 3308,
            IDFF_enc_skalMaskingAmp = 3309,

            IDFF_enc_theo_hq = 3196,
            IDFF_enc_theo_sharpness = 3329,
            IDFF_enc_theo_noisesensitivity = 3330,

            IDFF_enc_raw_fourcc = 3197,

            IDFF_enc_working = 3198,
            IDFF_enc_fpsRate = 3206,
            IDFF_enc_fpsScale = 3207,
            IDFF_enc_psnr = 3199,
            IDFF_enc_showGraph = 3204,
            //IDFF_enc_h_graph=3205,

            IDFF_dlgBpsFps1000 = 3208,
            IDFF_dlgBpsLen = 3209,
            IDFF_dlgPerfectDlgX = 3210,
            IDFF_dlgPerfectDlgY = 3211,
            IDFF_dlgEncGraph = 3219,
            IDFF_dlgEncAbout = 3220,

            //max:3369
        }
    }
}



